package com.easyproject.common.core.domain;

import com.easyproject.common.constant.HttpStatus;
import com.easyproject.common.utils.MessageUtils;
import com.easyproject.common.utils.StringUtils;

import java.util.HashMap;

/**
 * 用户端-操作消息提醒
 *
 * @author java001
 */
public class AjaxClientResult extends HashMap<String, Object>
{
    private static final long serialVersionUID = 1L;

    /** 状态码 */
    public static final String CODE_TAG = "code";

    /** 请求状态 */
    public static final String SUCCESS_TAG = "success";

    /** 返回内容 */
    public static final String MSG_TAG = "message";

    /** 数据对象 */
    public static final String DATA_TAG = "data";

    /**
     * 初始化一个新创建的 AjaxResult 对象，使其表示一个空消息。
     */
    public AjaxClientResult()
    {
    }

    /**
     * 初始化一个新创建的 AjaxResult 对象
     *
     * @param code 状态码
     * @param msg 返回内容
     */
    public AjaxClientResult(int code, String msg)
    {
        super.put(CODE_TAG, code);
        super.put(MSG_TAG, msg);
    }

    /**
     * 初始化一个新创建的 AjaxResult 对象
     *
     * @param code 状态码
     * @param msg 返回内容
     * @param data 数据对象
     */
    public AjaxClientResult(int code,Boolean success ,String msg, Object data)
    {
        super.put(CODE_TAG, code);
        super.put(SUCCESS_TAG, success);
        super.put(MSG_TAG, msg);
        super.put(DATA_TAG, data);
    }

    /**
     * 返回成功消息
     *
     * @return 成功消息
     */
    public static AjaxClientResult success()
    {
        return AjaxClientResult.success(MessageUtils.message("operation.successful"));
    }

    /**
     * 返回成功数据
     *
     * @return 成功消息
     */
    public static AjaxClientResult success(Object data)
    {
        return AjaxClientResult.success(MessageUtils.message("operation.successful"), data);
    }

    /**
     * 返回成功消息
     *
     * @param msg 返回内容
     * @return 成功消息
     */
    public static AjaxClientResult success(String msg)
    {
        return AjaxClientResult.success(msg, null);
    }

    /**
     * 返回成功消息
     *
     * @param msg 返回内容
     * @param data 数据对象
     * @return 成功消息
     */
    public static AjaxClientResult success(String msg, Object data)
    {
        return new AjaxClientResult(HttpStatus.SUCCESS, true, msg, data);
    }

    /**
     * 返回警告消息
     *
     * @param msg 返回内容
     * @return 警告消息
     */
    public static AjaxClientResult warn(String msg)
    {
        return AjaxClientResult.warn(msg, null);
    }

    /**
     * 返回警告消息
     *
     * @param msg 返回内容
     * @param data 数据对象
     * @return 警告消息
     */
    public static AjaxClientResult warn(String msg, Object data)
    {
        return new AjaxClientResult(HttpStatus.WARN, false, msg, data);
    }

    /**
     * 返回错误消息
     *
     * @return 错误消息
     */
    public static AjaxClientResult error()
    {
        return AjaxClientResult.error(MessageUtils.message("operation.failed"));
    }

    /**
     * 返回错误消息
     *
     * @param msg 返回内容
     * @return 错误消息
     */
    public static AjaxClientResult error(String msg)
    {
        return AjaxClientResult.error(msg, null);
    }

    /**
     * 返回错误消息
     *
     * @param msg 返回内容
     * @param data 数据对象
     * @return 错误消息
     */
    public static AjaxClientResult error(String msg, Object data)
    {
        return new AjaxClientResult(HttpStatus.ERROR,false, msg, data);
    }

    /**
     * 返回错误消息
     *
     * @param code 状态码
     * @param msg 返回内容
     * @return 错误消息
     */
    public static AjaxClientResult error(int code, String msg)
    {
        return new AjaxClientResult(code, false, msg, null);
    }

    /**
     * 方便链式调用
     *
     * @param key 键
     * @param value 值
     * @return 数据对象
     */
    @Override
    public AjaxClientResult put(String key, Object value)
    {
        super.put(key, value);
        return this;
    }
}
